#include"256col.h"

graph256col gl;

graph256col::graph256col()
{
 vb=(unsigned char far *)MK_FP(0xa000, 0);
 scan_vid();
 set_vid(19);
 curcol=7;
 clearcol=0;
 Mask=0xffff;
 dblbuf=0;
 retr=1;
 curmtx=&view;
 cullface=GL_BACK;
 tocullface=1;
 frontface=GL_CW;
 view.identity();
 proj.identity();
 curnormal.V[0]=curnormal.V[1]=0;
 curnormal.V[2]=curnormal.V[3]=1;
 lighting=0;
 normalize=0;
 perspective=0;
 L.V[0]=L.V[1]=L.V[3]=0;
 L.V[2]=-1;
 lightexp=63;
 phonglight=0;
 phongnormalize=0;
 depthtest=0;
 texturing=0;
 curtexu=curtexv=0;
 texfilter=GL_NEAREST;
}

graph256col::~graph256col()
{
 if(dblbuf)free(vb);
 _AH=0;
 _AL=old_vid;
 geninterrupt(16);
 _AH=5;
 _AL=old_page;
 geninterrupt(16);
}

void graph256col::scan_vid()
{
 _AH=0xf;
 geninterrupt(16);
 old_vid=_AL;
 old_page=_BH;
}

void graph256col::set_vid(unsigned short v)
{
 _AH=0;
 _AL=v;
 geninterrupt(16);
}

unsigned char graph256col::color(unsigned char col,unsigned char r,unsigned char g,unsigned char b)
{
 outportb(0x3c8,col);
 outportb(0x3c9,r);
 outportb(0x3c9,g);
 outportb(0x3c9,b);
 return col;
}

unsigned char graph256col::color(int x,int y)
{
 if(x>=0&&x<320&&y>=0&&y<200)
  return(*(vb+(y)*320+(x)));
 else
  return 0;
}

void graph256col::point(int x,int y)
{
 unsigned X=x,Y=y;
 if(x>=0&&x<320&&y>=0&&y<200)
  *(vb+Y*320+X)=curcol;
}

void graph256col::line(int x0,int y0,int x1,int y1)
{
 int dx=x1-x0;
 int dy=y1-y0;
 int iX,iY,sXY;
 int mc=2;
 int X=0,Y=0,d;
 sXY=abs(dx)<abs(dy);
 iX=dx<0;
 iY=dy<0;
 dx=abs(dx);
 dy=abs(dy);
 if(sXY)
 {
  d=dx;
  dx=dy;
  dy=d;
 }
 d=(dy<<1)-dx;
 if(Mask&1)point(x0,y0);
 for(X=1;X<=dx;X++)
 {
  if(d>0)
  {
   Y++;
   d=d+((dy-dx)<<1);
  }
  else
  {
   d=d+(dy<<1);
  }
  if(sXY)
  {
   if(iX) x1=-Y; else x1=Y;
   if(iY) y1=-X; else y1=X;
  }
  else
  {
   if(iX) x1=-X; else x1=X;
   if(iY) y1=-Y; else y1=Y;
  }
  if(Mask&mc)point(x0+x1,y0+y1);
  mc<<=1;
  if(mc==0)mc=1;
 }
}

void graph256col::triangle(int x0,int y0,int x1,int y1,int x2,int y2)
{
 int tmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
 }
 int y,xl,xr,x;
 if(y2==y0) return;
 for(y=y0>0?y0:0;y<=y2&&y<200;y++)
 {
  xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
  if(y<y1)
   xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
  else
  {
   if(y2==y1)
    xr=x1;
   else
    xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
  }
  if(xl>xr)
  {
   tmp=xl; xl=xr; xr=tmp;
  }
  if(xl<0) xl=0;
  if(xr>=320) xr=319;
  for(x=xl;x<=xr;x++)
   putpix(x,y);
 }
}

void graph256col::circle(int x,int y,int r)
{
 int d=3-(r<<1);
 int X=0,Y=r;
 int max=r/1.4142;
 for (X=0;X<=max;X++)
 {
  if(d<0)
  {
   d=d+(X<<2)+6;
  }
  else
  {
   d=d+((X-Y)<<2)+10;
   Y--;
  }
  point(x+X,y+Y);
  point(x-X,y+Y);
  point(x+X,y-Y);
  point(x-X,y-Y);
  point(x+Y,y+X);
  point(x-Y,y+X);
  point(x+Y,y-X);
  point(x-Y,y-X);
 }
}

void graph256col::fill(int x,int y)
{
 int xl,xr,need;
 fillcol=color(x,y);
 if(fillcol==curcol) return;
 asm {
  push -1
  push y
  push x
 }
 while(1)
 {
  asm pop x;
  //x=_AX;
  if(x==-1)break;
  asm pop y;
  //y=_AX;
  if(y==-1)break;
  xl=x;
  while(color(xl,y)==fillcol&&xl>=0)
  {
   putpix(xl,y);
   xl--;
  }
  xl++;
  xr=x+1;
  while(color(xr,y)==fillcol&&xr<320)
  {
   putpix(xr,y);
   xr++;
  }
  if(y>0)
  {
   x=xl;
   need=0;
   while(x<xr)
   {
    while(color(x,y-1)==fillcol&&x<xr) {x++;need=1;}
    if(need)
    {
     y--;
     x--;
     asm push y;
     asm push x;
     x++;
     y++;
     need=0;
    }
    while(color(x,y-1)!=fillcol&&x<xr) x++;
   }
  }
  if(y<199)
  {
   x=xl;
   need=0;
   while(x<xr)
   {
    while(color(x,y+1)==fillcol&&x<xr) {x++;need=1;}
    if(need)
    {
     y++;
     x--;
     asm push y;
     asm push x;
     x++;
     y--;
    }
    while(color(x,y+1)!=fillcol&&x<xr) x++;
   }
  }
 }
}

void graph256col::fill(int x,int y,unsigned char col)
{
 if(color(x,y)==col) return;
 int xl,xr,need;
 asm {
  push -1
  push y
  push x
 }
 while(1)
 {
  asm pop x;
  //x=_AX;
  if(x==-1)break;
  asm pop y;
  //y=_AX;
  if(y==-1)break;
  xl=x;
  while(color(xl,y)!=col&&xl>=0)
  {
   putpix(xl,y);
   xl--;
  }
  xl++;
  xr=x+1;
  while(color(xr,y)!=col&&xr<320)
  {
   putpix(xr,y);
   xr++;
  }
  if(y>0)
  {
   x=xl;
   need=0;
   y--;
   while(x<xr)
   {
    while(color(x,y)!=col&&color(x,y)!=curcol&&x<xr) {x++;need=1;}
    if(need)
    {
     x--;
     asm push y;
     asm push x;
     x++;
     need=0;
    }
    while((color(x,y)==col||color(x,y)==curcol)&&x<xr) x++;
   }
   y++;
  }
  if(y<199)
  {
   x=xl;
   need=0;
   y++;
   while(x<xr)
   {
    while(color(x,y)!=col&&color(x,y)!=curcol&&x<xr) {x++;need=1;}
    if(need)
    {
     x--;
     asm push y;
     asm push x;
     x++;
    }
    while((color(x,y)==col||color(x,y)==curcol)&&x<xr) x++;
   }
   y--;
  }
 }
}

void graph256col::flattriangle(vertex A,vertex B,vertex C)
{
 int x0,y0,x1,y1,x2,y2;
 int c0,c1,c2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 c0=A.col;
 c1=B.col;
 c2=C.col;
 int tmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=c1; c1=c0; c0=tmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=c2; c2=c0; c0=tmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=c2; c2=c1; c1=tmp;
 }
  int y,xl,xr,x;
  int cst,cen;
  if(y2==y0) return;
  cst=c0+(y1-y0)*(c2-c0)/(y2-y0);
  float t;
   t=x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1;
  float dc;
  if(t) dc=((float)(cst-c1))/(t);
  else dc=0;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   cst=(int)(c0+(long)(y-y0)*(c2-c0)/(y2-y0));
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    cen=(int)(c0+(long)(y-y0)*(c1-c0)/(y1-y0));
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     cen=c1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     cen=(int)(c1+(long)(y-y1)*(c2-c1)/(y2-y1));
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    cst=cen;
   }
   if(xr>=320) xr=319;
   for(x=xl>0?xl:0;x<xr;x++)
   {
    curcol=cst+dc*(x-xl);
    putpix(x,y);
   }
  }
}

void graph256col::texflattriangle(vertex A,vertex B,vertex C)
{
 int x0,y0,x1,y1,x2,y2;
 int c0,c1,c2;
 int u0,u1,u2,v0,v1,v2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 c0=A.col;
 c1=B.col;
 c2=C.col;
 u0=A.u;
 u1=B.u;
 u2=C.u;
 v0=A.v;
 v1=B.v;
 v2=C.v;
 int tmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=c1; c1=c0; c0=tmp;
  tmp=u1; u1=u0; u0=tmp;
  tmp=v1; v1=v0; v0=tmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=c2; c2=c0; c0=tmp;
  tmp=u2; u2=u0; u0=tmp;
  tmp=v2; v2=v0; v0=tmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=c2; c2=c1; c1=tmp;
  tmp=u2; u2=u1; u1=tmp;
  tmp=v2; v2=v1; v1=tmp;
 }
  int y,xl,xr,x;
  int cst,cen;
  int ust,uen,vst,ven;
  if(y2==y0) return;
  cst=(int)(c0+(long)(y1-y0)*(c2-c0)/(y2-y0));
  ust=(int)(u0+(long)(y1-y0)*(u2-u0)/(y2-y0));
  vst=(int)(v0+(long)(y1-y0)*(v2-v0)/(y2-y0));
  int t;
   t=(int)(x0+(long)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  float dc,du,dv;
  if(t)
  {
   dc=((float)(cst-c1))/(t);
   du=((float)(ust-u1))/(t);
   dv=((float)(vst-v1))/(t);
  }
  else
  {
   dc=0;
   du=0;
   dv=0;
  }
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   cst=(int)(c0+(long)(y-y0)*(c2-c0)/(y2-y0));
   ust=(int)(u0+(long)(y-y0)*(u2-u0)/(y2-y0));
   vst=(int)(v0+(long)(y-y0)*(v2-v0)/(y2-y0));
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    cen=(int)(c0+(long)(y-y0)*(c1-c0)/(y1-y0));
    uen=(int)(u0+(long)(y-y0)*(u1-u0)/(y1-y0));
    ven=(int)(v0+(long)(y-y0)*(v1-v0)/(y1-y0));
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     cen=c1;
     uen=u1;
     ven=v1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     cen=(int)(c1+(long)(y-y1)*(c2-c1)/(y2-y1));
     uen=(int)(u1+(long)(y-y1)*(u2-u1)/(y2-y1));
     ven=(int)(v1+(long)(y-y1)*(v2-v1)/(y2-y1));
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    cst=cen;
    ust=uen;
    vst=ven;
   }
   if(xr>=320) xr=319;
   for(x=xl>0?xl:0;x<xr;x++)
   {
    curcol=(float)texgetpix(ust+(x-xl)*du,vst+(x-xl)*dv)*(cst+(x-xl)*dc)/255.0;
    putpix(x,y);
   }
  }
}

void graph256col::triangle(vertex A,vertex B,vertex C)
{
 if(texturing)
 {
  textriangle(A,B,C);
  return;
 }
 if(A.col==B.col&&B.col==C.col)
 {
  curcol=A.col;
  triangle(A.V.V[0],A.V.V[1],B.V.V[0],B.V.V[1],C.V.V[0],C.V.V[1]);
  return;
 }
 if(!perspective||(A.V.V[2]==B.V.V[2]&&B.V.V[2]==C.V.V[2]))
 {
  flattriangle(A,B,C);
  return;
 }
 A.V.V[2]+=3;
 B.V.V[2]+=3;
 C.V.V[2]+=3;
 int x0,y0,x1,y1,x2,y2,c0,c1,c2;
 float _z0,_z1,_z2,_c0,_c1,_c2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 c0=A.col;
 c1=B.col;
 c2=C.col;
 _z0=1.0/A.V.V[2];
 _z1=1.0/B.V.V[2];
 _z2=1.0/C.V.V[2];
 int tmp;
 float ftmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=c1; c1=c0; c0=tmp;
  ftmp=_z1;_z1=_z0;_z0=ftmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=c2; c2=c0; c0=tmp;
  ftmp=_z2;_z2=_z0;_z0=ftmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=c2; c2=c1; c1=tmp;
  ftmp=_z2;_z2=_z1;_z1=ftmp;
 }
 if(y2==y0) return;
 _c0=c0*_z0;
 _c1=c1*_z1;
 _c2=c2*_z2;
 int y,xl,xr,x,xx;
 //float k02,k01,k12;
 float k_c02,k_c01,k_c12,k_z02,k_z01,k_z12;
 // k02=((float)(x2-x0))/(y2-y0);
  k_c02=(_c2-_c0)/(y2-y0);
  k_z02=(_z2-_z0)/(y2-y0);
 if(y1!=y0)
 {
 // k01=((float)(x1-x0))/(y1-y0);
  k_c01=(_c1-_c0)/(y1-y0);
  k_z01=(_z1-_z0)/(y1-y0);
 }
 if(y2!=y1)
 {
 // k12=((float)(x2-x1))/(y2-y1);
  k_c12=(_c2-_c1)/(y2-y1);
  k_z12=(_z2-_z1)/(y2-y1);
 }
  float _zl,_zr,_cl,_cr;
  _cl=_c0+(y1-y0)*k_c02;
  _zl=_z0+(y1-y0)*k_z02;
  float t;
  t=(x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  float d_c;
  if(t) d_c=(_cl-_c1)/t;
  else d_c=1;
  float d_z;
  if(t) d_z=(_zl-_z1)/t;
  else d_z=1;
  float cl,cr,dc;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   _cl=_c0+(y-y0)*k_c02;
   _zl=_z0+(y-y0)*k_z02;
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    _cr=_c0+(y-y0)*k_c01;
    _zr=_z0+(y-y0)*k_z01;
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     _cr=_c1;
     _zr=_z1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     _cr=_c1+(y-y1)*k_c12;
     _zr=_z1+(y-y1)*k_z12;
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    _cl=_cr;
    _zl=_zr;
   }
   if(xr>=320) xr=319;
    cl=_cl/_zl;
   for(x=xl;x<=xr-8;x+=8)
   {
    _cr=_cl+8.0*d_c;
    _zr=_zl+8.0*d_z;
    cr=_cr/_zr;
    dc=(cr-cl)/8.0;
    for(xx=0;xx<8;xx++)
    {
     curcol=cl;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
    }
    _cl=_cr;
    _zl=_zr;
    cl=cr;
   }
   int l=xr-x;
   if(l>0)
   {
    _cr=_cl+l*d_c;
    _zr=_zl+l*d_z;
     cr=_cr/_zr;
    dc=(cr-cl)/l;
    for(xx=0;xx<l;xx++)
    {
     curcol=cl;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
    }
   }
  }
}

void graph256col::textriangle(vertex A,vertex B,vertex C)
{
 if(A.col==B.col&&B.col==C.col)
 {
  curcol=A.col;
  textrianglenolight(A,B,C);
  return;
 }
 if(!perspective||(A.V.V[2]==B.V.V[2]&&B.V.V[2]==C.V.V[2]))
 {
  texflattriangle(A,B,C);
  return;
 }
 A.V.V[2]+=3;
 B.V.V[2]+=3;
 C.V.V[2]+=3;
 int x0,y0,x1,y1,x2,y2,c0,c1,c2,u0,u1,u2,v0,v1,v2;
 float _z0,_z1,_z2,_c0,_c1,_c2,_u0,_u1,_u2,_v0,_v1,_v2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 c0=A.col;
 c1=B.col;
 c2=C.col;
 u0=A.u;
 u1=B.u;
 u2=C.u;
 v0=A.v;
 v1=B.v;
 v2=C.v;
 _z0=1.0/A.V.V[2];
 _z1=1.0/B.V.V[2];
 _z2=1.0/C.V.V[2];
 int tmp;
 float ftmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=c1; c1=c0; c0=tmp;
  tmp=u1; u1=u0; u0=tmp;
  tmp=v1; v1=v0; v0=tmp;
  ftmp=_z1;_z1=_z0;_z0=ftmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=c2; c2=c0; c0=tmp;
  tmp=u2; u2=u0; u0=tmp;
  tmp=v2; v2=v0; v0=tmp;
  ftmp=_z2;_z2=_z0;_z0=ftmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=c2; c2=c1; c1=tmp;
  tmp=u2; u2=u1; u1=tmp;
  tmp=v2; v2=v1; v1=tmp;
  ftmp=_z2;_z2=_z1;_z1=ftmp;
 }
 if(y2==y0) return;
 _c0=c0*_z0;
 _c1=c1*_z1;
 _c2=c2*_z2;
 _u0=u0*_z0;
 _u1=u1*_z1;
 _u2=u2*_z2;
 _v0=v0*_z0;
 _v1=v1*_z1;
 _v2=v2*_z2;
 int y,xl,xr,x,xx;
 float k_c02,k_c01,k_c12,k_z02,k_z01,k_z12;
 float k_u02,k_u01,k_u12,k_v02,k_v01,k_v12;
  k_c02=(_c2-_c0)/(y2-y0);
  k_z02=(_z2-_z0)/(y2-y0);
  k_u02=(_u2-_u0)/(y2-y0);
  k_v02=(_v2-_v0)/(y2-y0);
 if(y1!=y0)
 {
  k_c01=(_c1-_c0)/(y1-y0);
  k_z01=(_z1-_z0)/(y1-y0);
  k_u01=(_u1-_u0)/(y1-y0);
  k_v01=(_v1-_v0)/(y1-y0);
 }
 if(y2!=y1)
 {
  k_c12=(_c2-_c1)/(y2-y1);
  k_z12=(_z2-_z1)/(y2-y1);
  k_u12=(_u2-_u1)/(y2-y1);
  k_v12=(_v2-_v1)/(y2-y1);
 }
  float _zl,_zr,_cl,_cr;
  float _ul,_ur,_vl,_vr;
  _cl=_c0+(y1-y0)*k_c02;
  _zl=_z0+(y1-y0)*k_z02;
  _ul=_u0+(y1-y0)*k_u02;
  _vl=_v0+(y1-y0)*k_v02;
  float t;
  t=(x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  float d_c,d_u,d_v;
  float d_z;
  if(t)
  {
   d_c=(_cl-_c1)/t;
   d_u=(_ul-_u1)/t;
   d_v=(_vl-_v1)/t;
   d_z=(_zl-_z1)/t;
  }
  else
  {
   d_c=1;
   d_u=1;
   d_v=1;
   d_z=1;
  }
  float cl,cr,dc,ul,ur,du,vl,vr,dv;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   _cl=_c0+(y-y0)*k_c02;
   _zl=_z0+(y-y0)*k_z02;
   _ul=_u0+(y-y0)*k_u02;
   _vl=_v0+(y-y0)*k_v02;
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    _cr=_c0+(y-y0)*k_c01;
    _zr=_z0+(y-y0)*k_z01;
    _ur=_u0+(y-y0)*k_u01;
    _vr=_v0+(y-y0)*k_v01;
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     _cr=_c1;
     _zr=_z1;
     _ur=_u1;
     _vr=_v1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     _cr=_c1+(y-y1)*k_c12;
     _zr=_z1+(y-y1)*k_z12;
     _ur=_u1+(y-y1)*k_u12;
     _vr=_v1+(y-y1)*k_v12;
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    _cl=_cr;
    _zl=_zr;
    _ul=_ur;
    _vl=_vr;
   }
   if(xr>=320) xr=319;
   cl=_cl/_zl;
   ul=_ul/_zl;
   vl=_vl/_zl;
   for(x=xl;x<=xr-8;x+=8)
   {
    _cr=_cl+8.0*d_c;
    _ur=_ul+8.0*d_u;
    _vr=_vl+8.0*d_v;
    _zr=_zl+8.0*d_z;
    cr=_cr/_zr;
    ur=_ur/_zr;
    vr=_vr/_zr;
    dc=(cr-cl)/8.0;
    du=(ur-ul)/8.0;
    dv=(vr-vl)/8.0;
    for(xx=0;xx<8;xx++)
    {
     curcol=(float)texgetpix(ul,vl)*cl/255.0;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
     ul+=du;
     vl+=dv;
    }
    _cl=_cr;
    _ul=_ur;
    _vl=_vr;
    _zl=_zr;
    cl=cr;
    ul=ur;
    vl=vr;
   }
   int l=xr-x;
   if(l>0)
   {
    _cr=_cl+l*d_c;
    _ur=_ul+l*d_u;
    _vr=_vl+l*d_v;
    _zr=_zl+l*d_z;
    cr=_cr/_zr;
    ur=_ur/_zr;
    vr=_vr/_zr;
    dc=(cr-cl)/l;
    du=(ur-ul)/l;
    dv=(vr-vl)/l;
    for(xx=0;xx<l;xx++)
    {
     curcol=(float)texgetpix(ul,vl)*cl/255.0;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
     ul+=du;
     vl+=dv;
    }
   }
  }
}

void graph256col::textrianglenolight(vertex A,vertex B,vertex C)
{
 float kc=(float)A.col/255.0;
 if(perspective)
 {
 A.V.V[2]+=3;
 B.V.V[2]+=3;
 C.V.V[2]+=3;
 int x0,y0,x1,y1,x2,y2,u0,u1,u2,v0,v1,v2;
 float _z0,_z1,_z2,_u0,_u1,_u2,_v0,_v1,_v2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 u0=A.u;
 u1=B.u;
 u2=C.u;
 v0=A.v;
 v1=B.v;
 v2=C.v;
 _z0=1.0/A.V.V[2];
 _z1=1.0/B.V.V[2];
 _z2=1.0/C.V.V[2];
 int tmp;
 float ftmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=u1; u1=u0; u0=tmp;
  tmp=v1; v1=v0; v0=tmp;
  ftmp=_z1;_z1=_z0;_z0=ftmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=u2; u2=u0; u0=tmp;
  tmp=v2; v2=v0; v0=tmp;
  ftmp=_z2;_z2=_z0;_z0=ftmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=u2; u2=u1; u1=tmp;
  tmp=v2; v2=v1; v1=tmp;
  ftmp=_z2;_z2=_z1;_z1=ftmp;
 }
 if(y2==y0) return;
 _u0=u0*_z0;
 _u1=u1*_z1;
 _u2=u2*_z2;
 _v0=v0*_z0;
 _v1=v1*_z1;
 _v2=v2*_z2;
 int y,xl,xr,x,xx;
 float k_z02,k_z01,k_z12;
 float k_u02,k_u01,k_u12,k_v02,k_v01,k_v12;
  k_z02=(_z2-_z0)/(y2-y0);
  k_u02=(_u2-_u0)/(y2-y0);
  k_v02=(_v2-_v0)/(y2-y0);
 if(y1!=y0)
 {
  k_z01=(_z1-_z0)/(y1-y0);
  k_u01=(_u1-_u0)/(y1-y0);
  k_v01=(_v1-_v0)/(y1-y0);
 }
 if(y2!=y1)
 {
  k_z12=(_z2-_z1)/(y2-y1);
  k_u12=(_u2-_u1)/(y2-y1);
  k_v12=(_v2-_v1)/(y2-y1);
 }
  float _zl,_zr;
  float _ul,_ur,_vl,_vr;
  _zl=_z0+(y1-y0)*k_z02;
  _ul=_u0+(y1-y0)*k_u02;
  _vl=_v0+(y1-y0)*k_v02;
  float t;
  t=(x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  float d_u,d_v;
  float d_z;
  if(t)
  {
   d_u=(_ul-_u1)/t;
   d_v=(_vl-_v1)/t;
   d_z=(_zl-_z1)/t;
  }
  else
  {
   d_u=1;
   d_v=1;
   d_z=1;
  }
  float ul,ur,du,vl,vr,dv;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   _zl=_z0+(y-y0)*k_z02;
   _ul=_u0+(y-y0)*k_u02;
   _vl=_v0+(y-y0)*k_v02;
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    _zr=_z0+(y-y0)*k_z01;
    _ur=_u0+(y-y0)*k_u01;
    _vr=_v0+(y-y0)*k_v01;
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     _zr=_z1;
     _ur=_u1;
     _vr=_v1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     _zr=_z1+(y-y1)*k_z12;
     _ur=_u1+(y-y1)*k_u12;
     _vr=_v1+(y-y1)*k_v12;
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    _zl=_zr;
    _ul=_ur;
    _vl=_vr;
   }
   if(xr>=320) xr=319;
   ul=_ul/_zl;
   vl=_vl/_zl;
   for(x=xl;x<=xr-8;x+=8)
   {
    _ur=_ul+8.0*d_u;
    _vr=_vl+8.0*d_v;
    _zr=_zl+8.0*d_z;
    ur=_ur/_zr;
    vr=_vr/_zr;
    du=(ur-ul)/8.0;
    dv=(vr-vl)/8.0;
    for(xx=0;xx<8;xx++)
    {
     curcol=kc*texgetpix(ul,vl);
     if(x+xx>=0)
      putpix(x+xx,y);
     ul+=du;
     vl+=dv;
    }
    _ul=_ur;
    _vl=_vr;
    _zl=_zr;
    ul=ur;
    vl=vr;
   }
   int l=xr-x;
   if(l>0)
   {
    _ur=_ul+l*d_u;
    _vr=_vl+l*d_v;
    _zr=_zl+l*d_z;
    ur=_ur/_zr;
    vr=_vr/_zr;
    du=(ur-ul)/l;
    dv=(vr-vl)/l;
    for(xx=0;xx<l;xx++)
    {
     curcol=kc*texgetpix(ul,vl);
     if(x+xx>=0)
      putpix(x+xx,y);
     ul+=du;
     vl+=dv;
    }
   }
  }
 }
 else
 {
 int x0,y0,x1,y1,x2,y2;
 int u0,u1,u2,v0,v1,v2;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 u0=A.u;
 u1=B.u;
 u2=C.u;
 v0=A.v;
 v1=B.v;
 v2=C.v;
 int tmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=u1; u1=u0; u0=tmp;
  tmp=v1; v1=v0; v0=tmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=u2; u2=u0; u0=tmp;
  tmp=v2; v2=v0; v0=tmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=u2; u2=u1; u1=tmp;
  tmp=v2; v2=v1; v1=tmp;
 }
  int y,xl,xr,x;
  int ust,uen,vst,ven;
  if(y2==y0) return;
  ust=(int)(u0+(long)(y1-y0)*(u2-u0)/(y2-y0));
  vst=(int)(v0+(long)(y1-y0)*(v2-v0)/(y2-y0));
  int t;
   t=x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1;
  float du,dv;
  if(t)
  {
   du=((float)(ust-u1))/(t);
   dv=((float)(vst-v1))/(t);
  }
  else
  {
   du=0;
   dv=0;
  }
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   ust=(int)(u0+(long)(y-y0)*(u2-u0)/(y2-y0));
   vst=(int)(v0+(long)(y-y0)*(v2-v0)/(y2-y0));
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    uen=(int)(u0+(long)(y-y0)*(u1-u0)/(y1-y0));
    ven=(int)(v0+(long)(y-y0)*(v1-v0)/(y1-y0));
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     uen=u1;
     ven=v1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     uen=(int)(u1+(long)(y-y1)*(u2-u1)/(y2-y1));
     ven=(int)(v1+(long)(y-y1)*(v2-v1)/(y2-y1));
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    ust=uen;
    vst=ven;
   }
   if(xr>=320) xr=319;
   for(x=xl>0?xl:0;x<=xr;x++)
   {
    curcol=kc*texgetpix(ust+(x-xl)*du,vst+(x-xl)*dv);
    putpix(x,y);
   }
  }
 }
}

void graph256col::triangle(vertex A,vertex B,vertex C,vector N0,vector N1,vector N2,vector L0,vector L1,vector L2)
{
 if(texturing)
 {
  textriangle(A,B,C,N0,N1,N2,L0,L1,L2);
  return;
 }
 int x0,y0,x1,y1,x2,y2;
 int col=((int)A.col+B.col+C.col)/3.0;
 float c;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 int tmp;
 vector vtmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  vtmp=N1;N1=N0; N0=vtmp;
  vtmp=L1;L1=L0; L0=vtmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  vtmp=N2;N2=N0; N0=vtmp;
  vtmp=L2;L2=L0; L0=vtmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  vtmp=N2;N2=N1; N1=vtmp;
  vtmp=L2;L2=L1; L1=vtmp;
 }
 if(y2==y0) return;
 int y,xl,xr,x,xx,i;
  vector Nl,Nr,Ll,Lr,Nt,Lt;
  for(i=0;i<3;i++)
  {
   Nl.V[i]=N0.V[i]+(y1-y0)*(N2.V[i]-N0.V[i])/(y2-y0);
   Ll.V[i]=L0.V[i]+(y1-y0)*(L2.V[i]-L0.V[i])/(y2-y0);
  }
  float t;
   t=(x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  vector dN,dL;
  if(t)
   for(i=0;i<3;i++)
   {
    dN.V[i]=(Nl.V[i]-N1.V[i])/t;
    dL.V[i]=(Ll.V[i]-L1.V[i])/t;
   }
  else
   for(i=0;i<3;i++)
   {
    dN.V[i]=0;
    dL.V[i]=0;
   }
  float cl,cr,dc;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   for(i=0;i<3;i++)
   {
    Nl.V[i]=N0.V[i]+(float)(y-y0)*(N2.V[i]-N0.V[i])/(y2-y0);
    Ll.V[i]=L0.V[i]+(float)(y-y0)*(L2.V[i]-L0.V[i])/(y2-y0);
   }
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    for(i=0;i<3;i++)
    {
     Nr.V[i]=N0.V[i]+(float)(y-y0)*(N1.V[i]-N0.V[i])/(y1-y0);
     Lr.V[i]=L0.V[i]+(float)(y-y0)*(L1.V[i]-L0.V[i])/(y1-y0);
    }
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     Nr=N1;
     Lr=L1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     for(i=0;i<3;i++)
     {
      Nr.V[i]=N1.V[i]+(float)(y-y1)*(N2.V[i]-N1.V[i])/(y2-y1);
      Lr.V[i]=L1.V[i]+(float)(y-y1)*(L2.V[i]-L1.V[i])/(y2-y1);
     }
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
//    vtmp=Nl;Nl=Nr; Nr=vtmp;
//    vtmp=Ll;Ll=Lr; Lr=vtmp;
    Nl=Nr;
    Ll=Lr;
   }
   if(xr>=320) xr=319;
/*   if(xr==xl)
    for(i=0;i<3;i++)
    {
     dN.V[i]=0;
     dL.V[i]=0;
    }
   else
    for(i=0;i<3;i++)
    {
     dN.V[i]=(Nr.V[i]-Nl.V[i])/(xr-xl);
     dL.V[i]=(Lr.V[i]-Ll.V[i])/(xr-xl);
    }*/
   if(phongnormalize)
   {
    Nt=Nl;
    Lt=Ll;
    Lt.normalize();
    Nt.normalize();
    c=1.0-Lt.scalmul(Nt);
   }
   else
    c=1.0-Ll.scalmul(Nl);
   cl=col-c*lightexp;
   for(x=xl;x<=xr-8;x+=8)
   {
    for(i=0;i<3;i++)
    {
     Nr.V[i]=Nl.V[i]+8.0*dN.V[i];
     Lr.V[i]=Ll.V[i]+8.0*dL.V[i];
    }
    if(phongnormalize)
    {
     Nt=Nr;
     Lt=Lr;
     Lt.normalize();
     Nt.normalize();
     c=1.0-Lt.scalmul(Nt);
    }
    else
     c=1.0-Lr.scalmul(Nr);
    cr=col-c*lightexp;
    dc=(cr-cl)/8.0;
    for(xx=0;xx<8;xx++)
    {
     curcol=cl;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
    }
    Nl=Nr;
    Ll=Lr;
    cl=cr;
   }
   int l=xr-x;
   if(l>0)
   {
    for(i=0;i<3;i++)
    {
     Nr.V[i]=Nl.V[i]+l*dN.V[i];
     Lr.V[i]=Ll.V[i]+l*dL.V[i];
    }
    if(phongnormalize)
    {
     Nt=Nr;
     Lt=Lr;
     Lt.normalize();
     Nt.normalize();
     c=1.0-Lt.scalmul(Nt);
    }
    else
     c=1.0-Lr.scalmul(Nr);
    cr=col-c*lightexp;
    dc=(cr-cl)/l;
    for(xx=0;xx<l;xx++)
    {
     curcol=cl;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
    }
   }
  }
}

void graph256col::textriangle(vertex A,vertex B,vertex C,vector N0,vector N1,vector N2,vector L0,vector L1,vector L2)
{
 A.V.V[2]+=3;
 B.V.V[2]+=3;
 C.V.V[2]+=3;
 int x0,y0,x1,y1,x2,y2,u0,u1,u2,v0,v1,v2;
 float _z0,_z1,_z2,_u0,_u1,_u2,_v0,_v1,_v2;
 int col=((int)A.col+B.col+C.col)/3.0;
 float c;
 x0=A.V.V[0];
 x1=B.V.V[0];
 x2=C.V.V[0];
 y0=A.V.V[1];
 y1=B.V.V[1];
 y2=C.V.V[1];
 u0=A.u;
 u1=B.u;
 u2=C.u;
 v0=A.v;
 v1=B.v;
 v2=C.v;
 _z0=1.0/A.V.V[2];
 _z1=1.0/B.V.V[2];
 _z2=1.0/C.V.V[2];
 int tmp;
 float ftmp;
 vector vtmp;
 if(y0>y1)
 {
  tmp=y1; y1=y0; y0=tmp;
  tmp=x1; x1=x0; x0=tmp;
  tmp=u1; u1=u0; u0=tmp;
  tmp=v1; v1=v0; v0=tmp;
  ftmp=_z1;_z1=_z0;_z0=ftmp;
  vtmp=N1;N1=N0; N0=vtmp;
  vtmp=L1;L1=L0; L0=vtmp;
 }
 if(y0>y2)
 {
  tmp=y2; y2=y0; y0=tmp;
  tmp=x2; x2=x0; x0=tmp;
  tmp=u2; u2=u0; u0=tmp;
  tmp=v2; v2=v0; v0=tmp;
  ftmp=_z2;_z2=_z0;_z0=ftmp;
  vtmp=N2;N2=N0; N0=vtmp;
  vtmp=L2;L2=L0; L0=vtmp;
 }
 if(y1>y2)
 {
  tmp=y2; y2=y1; y1=tmp;
  tmp=x2; x2=x1; x1=tmp;
  tmp=u2; u2=u1; u1=tmp;
  tmp=v2; v2=v1; v1=tmp;
  ftmp=_z2;_z2=_z1;_z1=ftmp;
  vtmp=N2;N2=N1; N1=vtmp;
  vtmp=L2;L2=L1; L1=vtmp;
 }
 if(y2==y0) return;
 _u0=u0*_z0;
 _u1=u1*_z1;
 _u2=u2*_z2;
 _v0=v0*_z0;
 _v1=v1*_z1;
 _v2=v2*_z2;
 int y,xl,xr,x,xx,i;
 float k_z02,k_z01,k_z12;
 float k_u02,k_u01,k_u12,k_v02,k_v01,k_v12;
  k_z02=(_z2-_z0)/(y2-y0);
  k_u02=(_u2-_u0)/(y2-y0);
  k_v02=(_v2-_v0)/(y2-y0);
 if(y1!=y0)
 {
  k_z01=(_z1-_z0)/(y1-y0);
  k_u01=(_u1-_u0)/(y1-y0);
  k_v01=(_v1-_v0)/(y1-y0);
 }
 if(y2!=y1)
 {
  k_z12=(_z2-_z1)/(y2-y1);
  k_u12=(_u2-_u1)/(y2-y1);
  k_v12=(_v2-_v1)/(y2-y1);
 }
  float _zl,_zr;
  float _ul,_ur,_vl,_vr;
  _zl=_z0+(y1-y0)*k_z02;
  _ul=_u0+(y1-y0)*k_u02;
  _vl=_v0+(y1-y0)*k_v02;
  vector Nl,Nr,Ll,Lr,Nt,Lt;
  for(i=0;i<3;i++)
  {
   Nl.V[i]=N0.V[i]+(y1-y0)*(N2.V[i]-N0.V[i])/(y2-y0);
   Ll.V[i]=L0.V[i]+(y1-y0)*(L2.V[i]-L0.V[i])/(y2-y0);
  }
  float t;
   t=(x0+(float)(y1-y0)*(x2-x0)/(y2-y0)-x1);
  vector dN,dL;
  float d_u,d_v;
  float d_z;
  if(t)
  {
   for(i=0;i<3;i++)
   {
    dN.V[i]=(Nl.V[i]-N1.V[i])/t;
    dL.V[i]=(Ll.V[i]-L1.V[i])/t;
   }
   d_u=(_ul-_u1)/t;
   d_v=(_vl-_v1)/t;
   d_z=(_zl-_z1)/t;
  }
  else
  {
   for(i=0;i<3;i++)
   {
    dN.V[i]=0;
    dL.V[i]=0;
   }
   d_u=1;
   d_v=1;
   d_z=1;
  }
  float cl,cr,dc;
  float ul,ur,du,vl,vr,dv;
  for(y=y0>0?y0:0;y<=y2&&y<200;y++)
  {
   xl=(int)(x0+(long)(y-y0)*(x2-x0)/(y2-y0));
   _zl=_z0+(y-y0)*k_z02;
   _ul=_u0+(y-y0)*k_u02;
   _vl=_v0+(y-y0)*k_v02;
   for(i=0;i<3;i++)
   {
    Nl.V[i]=N0.V[i]+(float)(y-y0)*(N2.V[i]-N0.V[i])/(y2-y0);
    Ll.V[i]=L0.V[i]+(float)(y-y0)*(L2.V[i]-L0.V[i])/(y2-y0);
   }
   if(y<y1)
   {
    xr=(int)(x0+(long)(y-y0)*(x1-x0)/(y1-y0));
    _zr=_z0+(y-y0)*k_z01;
    _ur=_u0+(y-y0)*k_u01;
    _vr=_v0+(y-y0)*k_v01;
    for(i=0;i<3;i++)
    {
     Nr.V[i]=N0.V[i]+(float)(y-y0)*(N1.V[i]-N0.V[i])/(y1-y0);
     Lr.V[i]=L0.V[i]+(float)(y-y0)*(L1.V[i]-L0.V[i])/(y1-y0);
    }
   }
   else
   {
    if(y2==y1)
    {
     xr=x1;
     _zr=_z1;
     _ur=_u1;
     _vr=_v1;
     Nr=N1;
     Lr=L1;
    }
    else
    {
     xr=(int)(x1+(long)(y-y1)*(x2-x1)/(y2-y1));
     _zr=_z1+(y-y1)*k_z12;
     _ur=_u1+(y-y1)*k_u12;
     _vr=_v1+(y-y1)*k_v12;
     for(i=0;i<3;i++)
     {
      Nr.V[i]=N1.V[i]+(float)(y-y1)*(N2.V[i]-N1.V[i])/(y2-y1);
      Lr.V[i]=L1.V[i]+(float)(y-y1)*(L2.V[i]-L1.V[i])/(y2-y1);
     }
    }
   }
   if(xl>xr)
   {
    tmp=xl; xl=xr; xr=tmp;
    _zl=_zr;
    _ul=_ur;
    _vl=_vr;
    Nl=Nr;
    Ll=Lr;
   }
   if(xr>=320) xr=319;
   ul=_ul/_zl;
   vl=_vl/_zl;
   if(phongnormalize)
   {
    Nt=Nl;
    Lt=Ll;
    Lt.normalize();
    Nt.normalize();
    c=1.0-Lt.scalmul(Nt);
   }
   else
    c=1.0-Ll.scalmul(Nl);
   cl=col-c*lightexp;
   for(x=xl;x<=xr-8;x+=8)
   {
    for(i=0;i<3;i++)
    {
     Nr.V[i]=Nl.V[i]+8.0*dN.V[i];
     Lr.V[i]=Ll.V[i]+8.0*dL.V[i];
    }
    if(phongnormalize)
    {
     Nt=Nr;
     Lt=Lr;
     Lt.normalize();
     Nt.normalize();
     c=1.0-Lt.scalmul(Nt);
    }
    else
     c=1.0-Lr.scalmul(Nr);
    cr=col-c*lightexp;
    dc=(cr-cl)/8.0;
    _ur=_ul+8.0*d_u;
    _vr=_vl+8.0*d_v;
    _zr=_zl+8.0*d_z;
    ur=_ur/_zr;
    vr=_vr/_zr;
    du=(ur-ul)/8.0;
    dv=(vr-vl)/8.0;
    for(xx=0;xx<8;xx++)
    {
     curcol=(float)texgetpix(ul,vl)*cl/255.0;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
     ul+=du;
     vl+=dv;
    }
    Nl=Nr;
    Ll=Lr;
    cl=cr;
    _ul=_ur;
    _vl=_vr;
    _zl=_zr;
    ul=ur;
    vl=vr;
   }
   int l=xr-x;
   if(l>0)
   {
    for(i=0;i<3;i++)
    {
     Nr.V[i]=Nl.V[i]+l*dN.V[i];
     Lr.V[i]=Ll.V[i]+l*dL.V[i];
    }
    if(phongnormalize)
    {
     Nt=Nr;
     Lt=Lr;
     Lt.normalize();
     Nt.normalize();
     c=1.0-Lt.scalmul(Nt);
    }
    else
     c=1.0-Lr.scalmul(Nr);
    cr=col-c*lightexp;
    dc=(cr-cl)/l;
    _ur=_ul+l*d_u;
    _vr=_vl+l*d_v;
    _zr=_zl+l*d_z;
    ur=_ur/_zr;
    vr=_vr/_zr;
    du=(ur-ul)/l;
    dv=(vr-vl)/l;
    for(xx=0;xx<l;xx++)
    {
     curcol=(float)texgetpix(ul,vl)*cl/255.0;
     if(x+xx>=0)
      putpix(x+xx,y);
     cl+=dc;
     ul+=du;
     vl+=dv;
    }
   }
  }
}

int graph256col::Enable(GLenum mode)
{
 switch(mode)
 {
  case GL_DOUBLEBUFFER:
   if(!dblbuf)
   {
    vb=(unsigned char *)malloc(64000u);
    if(!vb)
    {
     vb=(unsigned char far *)MK_FP(0xa000, 0);
     return 0;
    }
    unsigned char col=color();
    color(0);
    Clear();
    color(col);
   }
   dblbuf=1;
   return dblbuf;
  case GL_WAITRETRACE:
   retr=1;
   return retr;
  case GL_CULL_FACE:
   tocullface=1;
   return 1;
  case GL_LIGHTING:
   lighting=1;
   return 1;
  case GL_NORMALIZE:
   normalize=1;
   return 1;
  case GL_PERSPECTIVE_CORRECTION:
   perspective=1;
   return 1;
  case GL_PHONG_LIGHTING:
   phonglight=1;
   return 1;
  case GL_PHONG_NORMALIZE:
   phongnormalize=1;
   return 1;
  case GL_DEPTH_TEST:
   depthtest=1;
   return 1;
  case GL_TEXTURE_2D:
   texturing=1;
   return 1;
 }
 return 1;
}

int graph256col::Disable(GLenum mode)
{
 switch(mode)
 {
  case GL_DOUBLEBUFFER:
   if(dblbuf)
   {
    free(vb);
    vb=(unsigned char far *)MK_FP(0xa000, 0);
   }
   dblbuf=0;
   return dblbuf;
  case GL_WAITRETRACE:
   retr=0;
   return retr;
  case GL_CULL_FACE:
   tocullface=0;
   return 0;
  case GL_LIGHTING:
   lighting=0;
   return 0;
  case GL_NORMALIZE:
   normalize=0;
   return 0;
  case GL_PERSPECTIVE_CORRECTION:
   perspective=0;
   return 0;
  case GL_PHONG_LIGHTING:
   phonglight=0;
   return 0;
  case GL_PHONG_NORMALIZE:
   phongnormalize=0;
   return 0;
  case GL_DEPTH_TEST:
   depthtest=0;
   return 0;
  case GL_TEXTURE_2D:
   texturing=0;
   return 0;
 }
 return 0;
}

void graph256col::swapbuffers()
{
 if(retr) while(!(inportb(0x3da)&8));//&8 for Vsinc //&1 for Hsync
 if(!dblbuf) return;
 /*unsigned char far* v=(unsigned char far *)MK_FP(0xa000, 0);
  for(unsigned i=0;i<64000u;i++)
  v[i]=vb[i];*/
 int s=FP_SEG(vb);
 int o=FP_OFF(vb);
 asm cli;
 asm cld;
 asm push ds;
 asm mov ax,0xa000;
 asm mov es,ax;
 asm mov di,0;
 asm mov ax,s;
 asm mov ds,ax;
 asm mov si,o;
 asm mov cx,32000;
 asm rep movsw;
 asm pop ds;
 asm sti;
}

void graph256col::Clear()
{
 /*for(unsigned i=0;i<64000u;i++)
  vb[i]=clearcol;*/
 int s=FP_SEG(vb);
 int o=FP_OFF(vb);
 unsigned char col=clearcol;
 asm cli;
 asm cld;
 asm mov ax,s;
 asm mov es,ax;
 asm mov di,o;
 asm mov cx,64000;
 asm mov al, col;
 asm rep stosb;
 asm sti;
}

void graph256col::Begin(GLenum m)
{
 mode=m;
 vrtx.clear();
 norm.clear();
 ligt.clear();
 tang.clear();
}

void graph256col::End()
{
 int i;
 vertex V1,V2,V3;
 triz T;
 unsigned char col=curcol;
 switch(mode)
 {
  case GL_POINTS:
   for(i=0;i<vrtx.length();i++)
   {
    V1=vrtx.get(i);
    curcol=V1.col;
    point(V1.V.V[0],V1.V.V[1]);
   }
  break;
  case GL_LINES:
   for(i=1;i<vrtx.length();i+=2)
   {
    V1=vrtx.get(i-1);
    V2=vrtx.get(i);
    curcol=((int)V1.col+V2.col)/2;
    line(V1.V.V[0],V1.V.V[1],V2.V.V[0],V2.V.V[1]);
   }
  break;
  case GL_LINE_STRIP:
   for(i=1;i<vrtx.length();i++)
   {
    V1=vrtx.get(i-1);
    V2=vrtx.get(i);
    curcol=((int)V1.col+V2.col)/2;
    line(V1.V.V[0],V1.V.V[1],V2.V.V[0],V2.V.V[1]);
   }
  break;
  case GL_LINE_LOOP:
   for(i=1;i<vrtx.length();i++)
   {
    V1=vrtx.get(i-1);
    V2=vrtx.get(i);
    curcol=((int)V1.col+V2.col)/2;
    line(V1.V.V[0],V1.V.V[1],V2.V.V[0],V2.V.V[1]);
   }
   V1=vrtx.get(vrtx.length()-1);
   V2=vrtx.get(0);
   curcol=((int)V1.col+V2.col)/2;
   line(V1.V.V[0],V1.V.V[1],V2.V.V[0],V2.V.V[1]);
  break;
  case GL_TRIANGLES:
   for(i=2;i<vrtx.length();i+=3)
   {
    V1=vrtx.get(i-2);
    V2=vrtx.get(i-1);
    V3=vrtx.get(i);
    if(showtriangle(V1.V,V2.V,V3.V))
    {
     if(depthtest)
     {
      T.z=(V1.V.V[2]+V2.V.V[2]+V3.V.V[2])/3.0;
      T.n=i;
      tang.add(T);
     }
     else if(lighting&&phonglight) triangle(V1,V2,V3,norm.get(i-2),norm.get(i-1),norm.get(i),ligt.get(i-2),ligt.get(i-1),ligt.get(i));
     else triangle(V1,V2,V3);
    }
   }
   if(depthtest)
   {
    tang.sort();
    for(i=0;i<tang.length();i++)
    {
     T=tang.get(i);
     V1=vrtx.get(T.n-2);
     V2=vrtx.get(T.n-1);
     V3=vrtx.get(T.n);
     if(lighting&&phonglight) triangle(V1,V2,V3,norm.get(T.n-2),norm.get(T.n-1),norm.get(T.n),ligt.get(T.n-2),ligt.get(T.n-1),ligt.get(T.n));
     else triangle(V1,V2,V3);
    }
   }
  break;
  case GL_TRIANGLE_STRIP:
   for(i=2;i<vrtx.length();i++)
   {
    if(i&1)
    {
     V1=vrtx.get(i-1);
     V2=vrtx.get(i-2);
    }
    else
    {
     V2=vrtx.get(i-1);
     V1=vrtx.get(i-2);
    }
    V3=vrtx.get(i);
    if(showtriangle(V1.V,V2.V,V3.V))
    {
     if(depthtest)
     {
      T.z=(V1.V.V[2]+V2.V.V[2]+V3.V.V[2])/3.0;
      T.n=i;
      tang.add(T);
     }
     else if(lighting&&phonglight) triangle(V1,V2,V3,
		    (i&1)?norm.get(i-1):norm.get(i-2),
		    (i&1)?norm.get(i-2):norm.get(i-1),
		    norm.get(i),
		    (i&1)?ligt.get(i-1):ligt.get(i-2),
		    (i&1)?ligt.get(i-2):ligt.get(i-1),
		    ligt.get(i));
     else triangle(V1,V2,V3);
    }
   }
   if(depthtest)
   {
    tang.sort();
    for(i=0;i<tang.length();i++)
    {
     T=tang.get(i);
     if(T.n&1)
     {
      V1=vrtx.get(T.n-1);
      V2=vrtx.get(T.n-2);
     }
     else
     {
      V2=vrtx.get(T.n-1);
      V1=vrtx.get(T.n-2);
     }
     V3=vrtx.get(T.n);
     if(lighting&&phonglight) triangle(V1,V2,V3,
		    (T.n&1)?norm.get(T.n-1):norm.get(T.n-2),
		    (T.n&1)?norm.get(T.n-2):norm.get(T.n-1),
		    norm.get(T.n),
		    (T.n&1)?ligt.get(T.n-1):ligt.get(T.n-2),
		    (T.n&1)?ligt.get(T.n-2):ligt.get(T.n-1),
		    ligt.get(T.n));
     else triangle(V1,V2,V3);
    }
   }
  break;
  case GL_TRIANGLE_FAN:
   V1=vrtx.get(0);
   for(i=2;i<vrtx.length();i++)
   {
    V2=vrtx.get(i-1);
    V3=vrtx.get(i);
    if(showtriangle(V1.V,V2.V,V3.V))
    {
     if(depthtest)
     {
      T.z=(V1.V.V[2]+V2.V.V[2]+V3.V.V[2])/3.0;
      T.n=i;
      tang.add(T);
     }
     else if(lighting&&phonglight) triangle(V1,V2,V3,norm.get(0),norm.get(i-1),norm.get(i),ligt.get(0),ligt.get(i-1),ligt.get(i));
     else triangle(V1,V2,V3);
    }
   }
   if(depthtest)
   {
    tang.sort();
    V1=vrtx.get(0);
    for(i=0;i<tang.length();i++)
    {
     T=tang.get(i);
     V2=vrtx.get(T.n-1);
     V3=vrtx.get(T.n);
     if(lighting&&phonglight) triangle(V1,V2,V3,norm.get(0),norm.get(T.n-1),norm.get(T.n),ligt.get(0),ligt.get(T.n-1),ligt.get(T.n));
     else triangle(V1,V2,V3);
    }
   }
  break;
 }
 curcol=col;
}

void graph256col::MatrixMode(GLenum mode)
{
 switch(mode)
 {
  case GL_MODELVIEW:
   curmtx=&view;
  break;
  case GL_PROJECTION:
   curmtx=&proj;
  break;
 }
}

void graph256col::LoadMatrixf(float* f)
{
 int i,j;
 for(j=0;j<4;j++)
  for(i=0;i<4;i++)
   curmtx->M[i][j]=f[i+j*4];
}

void graph256col::MultMatrixf(float* f)
{
 matrix tmp;
 int i,j;
 for(j=0;j<4;j++)
  for(i=0;i<4;i++)
  {
   tmp.M[i][j]=f[i+j*4];
  }
 curmtx->mul(tmp);
}

void graph256col::Rotatef(float ang,float i,float j,float k)
{
 ang=ang/180.0*M_PI;
 if(i==0&&j==0)
 {
  rotateZ(ang);
 }
 else if(i==0&&k==0)
 {
  rotateY(ang);
 }
 else if(j==0&&k==0)
 {
  rotateX(ang);
 }
 else
 {
  float ro=sqrt(i*i+j*j+k*k);
  float teta;
  if(i>0) teta=atan(j/i);
  else if(i<0) teta=M_PI+atan(j/i);
  else if(j>=0) teta=M_PI_2;
  else teta=M_PI+M_PI_2;
  float phi=acos(k/ro);
  rotateZ(teta);
  rotateY(phi);
  rotateZ(ang);
  rotateY(-phi);
  rotateZ(-teta);
 }
}

void graph256col::rotateZ(float ang)
{
 matrix tmp;
 tmp.identity();
 float s=sin(ang);
 float c=cos(ang);
 tmp.M[0][0]=c;
 tmp.M[0][1]=-s;
 tmp.M[1][1]=c;
 tmp.M[1][0]=s;
 curmtx->mul(tmp);
}

void graph256col::rotateX(float ang)
{
 matrix tmp;
 tmp.identity();
 float s=sin(ang);
 float c=cos(ang);
 tmp.M[1][1]=c;
 tmp.M[1][2]=-s;
 tmp.M[2][2]=c;
 tmp.M[2][1]=s;
 curmtx->mul(tmp);
}

void graph256col::rotateY(float ang)
{
 matrix tmp;
 tmp.identity();
 float s=sin(ang);
 float c=cos(ang);
 tmp.M[2][2]=c;
 tmp.M[2][0]=-s;
 tmp.M[0][0]=c;
 tmp.M[0][2]=s;
 curmtx->mul(tmp);
}

void graph256col::Translatef(float x,float y,float z)
{
 matrix tmp;
 tmp.identity();
 tmp.M[0][3]=x;
 tmp.M[1][3]=y;
 tmp.M[2][3]=z;
 curmtx->mul(tmp);
}

void graph256col::Scalef(float x,float y,float z)
{
 matrix tmp;
 tmp.identity();
 tmp.M[0][0]=x;
 tmp.M[1][1]=y;
 tmp.M[2][2]=z;
 curmtx->mul(tmp);
}

void graph256col::Ortho(float l,float r,float b,float t,float n,float f)
{
 float t1,t2,t3;
 t1=1.0/(r-l);
 t2=1.0/(t-b);
 t3=1.0/(f-n);
 matrix tmp;
 tmp.identity();
 tmp.M[0][0]=2.0*t1;
 tmp.M[1][1]=2.0*t2;
 tmp.M[2][2]=-2.0*t3;
 tmp.M[0][3]=-(r+l)*t1;
 tmp.M[1][3]=-(t+b)*t2;
 tmp.M[2][3]=-(f+n)*t3;
 curmtx->mul(tmp);
}

void graph256col::Frustum(float l,float r,float b,float t,float n,float f)
{
 float t1,t2,t3;
 t1=1.0/(r-l);
 t2=1.0/(t-b);
 t3=1.0/(f-n);
 matrix tmp;
 tmp.identity();
 tmp.M[0][0]=2.0*n*t1;
 tmp.M[1][1]=2.0*n*t2;
 tmp.M[0][2]=(r+l)*t1;
 tmp.M[1][2]=(t+b)*t2;
 tmp.M[2][2]=-(f+n)*t3;
 tmp.M[2][3]=-2.0*f*n*t3;
 tmp.M[3][2]=-1;
 tmp.M[3][3]=0;
 curmtx->mul(tmp);
}

void graph256col::Vertex3f(float x,float y,float z)
{
 vertex v;
 v.V.V[0]=x;
 v.V.V[1]=y;
 v.V.V[2]=z;
 v.V.V[3]=1;
 transform(v);
 v.u=curtexu;
 v.v=curtexv;
 vrtx.add(v);
}

void graph256col::Normal3f(float x,float y,float z)
{
 vector v;
 v.V[0]=x;
 v.V[1]=y;
 v.V[2]=z;
 v.V[3]=1;
 curnormal=v;
}

void graph256col::Vertex3fv(float* vect)
{
 vertex v;
 v.V.V[0]=vect[0];
 v.V.V[1]=vect[1];
 v.V.V[2]=vect[2];
 v.V.V[3]=1;
 v.u=curtexu;
 v.v=curtexv;
 transform(v);
 vrtx.add(v);
}

void graph256col::Normal3fv(float* vect)
{
 vector v;
 v.V[0]=vect[0];
 v.V[1]=vect[1];
 v.V[2]=vect[2];
 v.V[3]=1;
 curnormal=v;
}

void graph256col::Vertex2f(float x,float y)
{
 vertex v;
 v.V.V[0]=x;
 v.V.V[1]=y;
 v.V.V[2]=0;
 v.V.V[3]=1;
 v.u=curtexu;
 v.v=curtexv;
 transform(v);
 vrtx.add(v);
}

void graph256col::TexCoord2f(float s,float t)
{
 curtexu=s*(texcx-1);
 curtexv=t*(texcy-1);
}

void graph256col::Lighti(GLenum light,GLenum pname,int param)
{
 if(light==GL_LIGHT0)
 switch(pname)
 {
  case GL_SPOT_EXPONENT:
   lightexp=param;
  break;
 }
}

void graph256col::Lightfv(GLenum light,GLenum pname,float* params)
{
 if(light==GL_LIGHT0)
 switch(pname)
 {
  case GL_POSITION:
   L.V[0]=params[0];
   L.V[1]=params[1];
   L.V[2]=params[2];
   L.V[3]=params[3];
//   L.trans(view);
//   L.trans(proj);
//   L.divw();
  break;
 }
}

void graph256col::transform(vertex& V)
{
 if(lighting)
 {
  vector N;
  N.V[0]=V.V.V[0]+curnormal.V[0];
  N.V[1]=V.V.V[1]+curnormal.V[1];
  N.V[2]=V.V.V[2]+curnormal.V[2];
  N.V[3]=1;
  N.trans(view);
  N.trans(proj);
  N.divw();
  V.V.trans(view);
  V.V.trans(proj);
  V.V.divw();
  N.V[0]=N.V[0]-V.V.V[0];
  N.V[1]=N.V[1]-V.V.V[1];
  N.V[2]=N.V[2]-V.V.V[2];
  N.V[3]=1;
  vector tmp;
  tmp.V[0]=L.V[0]-V.V.V[0];
  tmp.V[1]=L.V[1]-V.V.V[1];
  tmp.V[2]=L.V[2]-V.V.V[2];
  tmp.normalize();
  /*if(normalize)*/ N.normalize();
  if(phonglight)
  {
   norm.add(N);
   ligt.add(tmp);
   V.col=curcol;
  }
  else
  {
   float c=1.0-tmp.scalmul(N);
   V.col=curcol-c*lightexp;
  }
 }
 else
 {
  V.V.trans(view);
  V.V.trans(proj);
  V.V.divw();
  V.col=curcol;
 }
 V.V.toscreen();
}

int graph256col::showtriangle(vector& A,vector& B,vector& C)
{
 if(((int)A.V[0]==(int)B.V[0]&&(int)A.V[1]==(int)B.V[1])
     ||((int)A.V[0]==(int)C.V[0]&&(int)A.V[1]==(int)C.V[1])
     ||((int)C.V[0]==(int)B.V[0]&&(int)C.V[1]==(int)B.V[1]))
        return 0;
 if(!tocullface) return 1;
 float z;
 z=(B.V[0]-A.V[0])*(C.V[1]-A.V[1])-(B.V[1]-A.V[1])*(C.V[0]-A.V[0]);
 if(z==0) return 0;
 return ((z>0)==(frontface==GL_CW)==(cullface==GL_BACK));
}

void graph256col::TexImage2D(GLenum target,int level,int components
       ,int width,int height
       ,int border,GLenum format,GLenum type,const void* pixels)
{
 if(target==GL_TEXTURE_2D&&level==0&&components==1&&border==0
    &&format==GL_COLOR_INDEX&&type==GL_UNSIGNED_BYTE&&pixels)
 {
  texcx=width;
  texcy=height;
  texpixels=(unsigned char*)pixels;
 }
}

void graph256col::TexParameteri(GLenum target,GLenum pname,GLenum param)
{
 if(target==GL_TEXTURE_2D&&pname==GL_TEXTURE_MAG_FILTER)
  texfilter=param;
}

unsigned char graph256col::texgetpix(float u,float v)
{
 switch(texfilter)
 {
  case GL_NEAREST:
   return texpixels[(int)v*texcx+(int)u];
  case GL_LINEAR:
   float c1,c2;
   float l,r;
   int x=u;
   if(x>=texcx) x=texcx-2;
   int y=v;
   if(y>=texcy) y=texcy-2;
   float kx=u-x;
   float ky=v-y;
   c1=texpixels[y*texcx+x];
   c2=texpixels[(y+1)*texcx+x];
   l=c1+(c2-c1)*ky;
   c1=texpixels[y*texcx+x+1];
   c2=texpixels[(y+1)*texcx+x+1];
   r=c1+(c2-c1)*ky;
   return l+(r-l)*kx;
  default: return 0;
 }
}

void matrix::identity()
{
 for(int i=0;i<4;i++)
  for(int j=0;j<4;j++)
   M[i][j]=(i==j?1:0);
}

void matrix::add(matrix& B)
{
 for(int i=0;i<4;i++)
  for(int j=0;j<4;j++)
   M[i][j]+=B.M[i][j];
}

void matrix::mul(matrix& B)
{
 float tmp[4][4];
 int i,j,k;
 float sum;
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
   tmp[i][j]=M[i][j];
 for(i=0;i<4;i++)
  for(j=0;j<4;j++)
  {
   sum=0;
   for(k=0;k<4;k++)
    sum+=tmp[i][k]*B.M[k][j];
   M[i][j]=sum;
  }
}

matrix& matrix::operator = (matrix& B)
{
 for(int i=0;i<4;i++)
  for(int j=0;j<4;j++)
   M[i][j]=B.M[i][j];
 return *this;
}

float vector::scalmul(vector& B)
{
 float res=0;
 for(int i=0;i<3;i++)
  res+=V[i]*B.V[i];
 return res;
}

void vector::vectmul(vector& B)
{
 float tmp[4];
 for(int i=0;i<4;i++)
  tmp[i]=V[i];
 V[0]=tmp[1]*B.V[2]-tmp[2]*B.V[1];
 V[1]=tmp[2]*B.V[0]-tmp[0]*B.V[2];
 V[2]=tmp[0]*B.V[1]-tmp[1]*B.V[0];
}

void vector::trans(matrix& T)
{
 float tmp[4];
 float sum;
 int i,j;
 for(i=0;i<4;i++)
  tmp[i]=V[i];
 for(i=0;i<4;i++)
  {
   sum=0;
   for(j=0;j<4;j++)
    sum+=T.M[i][j]*tmp[j];
   V[i]=sum;
  }
}

void vector::rotate(matrix& T)
{
 float tmp[3];
 float sum;
 int i,j;
 for(i=0;i<3;i++)
  tmp[i]=V[i];
 for(i=0;i<3;i++)
  {
   sum=0;
   for(j=0;j<3;j++)
    sum+=T.M[i][j]*tmp[j];
   V[i]=sum;
  }
}

void vector::divw()
{
 if(V[3])
 {
  V[0]/=V[3];
  V[1]/=V[3];
  V[2]/=V[3];
  V[3]=1.0;
 }
}

void vector::toscreen()
{
 V[0]=(++V[0])*160;
// V[1]=100-V[1]*83;
 V[1]=100-V[1]*100;
}

float vector::length()
{
// if(V[0]&&V[1]&&V[2])
  return sqrt(V[0]*V[0]+V[1]*V[1]+V[2]*V[2]);
// return 0;
}

void vector::normalize()
{
 float l=length();
 if(l>0)
 {
  V[0]/=l;
  V[1]/=l;
  V[2]/=l;
 }
}

vector& vector::operator = (vector& B)
{
 for(int i=0;i<4;i++)
  V[i]=B.V[i];
 return *this;
}

template <class T> list<T>::list()
{
 buf=NULL;
 size=0;
}

template <class T> list<T>::~list()
{
 if(buf) free(buf);
}

template <class T> void list<T>::add(T& V)
{
 size++;
 buf=(T*)realloc(buf,size*sizeof(T));
 if(!buf) clear();
 buf[size-1]=V;
}

template <class T> void list<T>::clear()
{
 if(buf) free(buf);
 buf=NULL;
 size=0;
}

template <class T> void list<T>::sort()
{
 int i,j,gap,k;
 T x;
 char a[5]={9,5,3,2,1};
 for(k=0;k<5;k++)
 {
  gap=a[k];
  for(i=gap;i<size;i++)
  {
   x=buf[i];
   for(j=i-gap; x<buf[j] && j>=0; j-=gap)
    buf[j+gap]=buf[j];
   buf[j+gap]=x;
  }
 }
}

