#include"256col.cpp"
#include<conio.h>
#include<stdlib.h>
#include<stdio.h>

float *P,*N;
int Csm=16,Clg=16;
int Rsm=20,Rlg=50;

void createtorus()
{
 P=(float*)realloc(P,sizeof(float)*3*Csm*Clg);
 N=(float*)realloc(N,sizeof(float)*3*Csm*Clg);
 if(!(P||N)) {printf("Not enough memory for torus %dx%d",Clg,Csm);getch();exit(1);};
 float ang1,ang2;
 float Pt[3],Ptt[3];
 int i,j;
 for(i=0;i<Clg;i++)
  for(j=0;j<Csm;j++)
  {
   ang1=2.0*M_PI/Clg*i;
   ang2=2.0*M_PI/Csm*j;
   Pt[0]=0;
   Pt[1]=0;
   Pt[2]=Rsm;
   Ptt[0]=Pt[0]*cos(ang2)-Pt[2]*sin(ang2);
   Ptt[2]=Pt[0]*sin(ang2)+Pt[2]*cos(ang2);
   Ptt[1]=Pt[1];
   Ptt[0]+=Rlg;
   Pt[0]=Ptt[0]*cos(ang1)-Ptt[1]*sin(ang1);
   Pt[1]=Ptt[0]*sin(ang1)+Ptt[1]*cos(ang1);
   Pt[2]=Ptt[2];
   P[(i*Csm+j)*3]=Pt[0];
   P[(i*Csm+j)*3+1]=Pt[1];
   P[(i*Csm+j)*3+2]=Pt[2];
   Pt[0]=0;
   Pt[1]=0;
   Pt[2]=1;
   Ptt[0]=Pt[0]*cos(ang2)-Pt[2]*sin(ang2);
   Ptt[2]=Pt[0]*sin(ang2)+Pt[2]*cos(ang2);
   Ptt[1]=Pt[1];
   Pt[0]=Ptt[0]*cos(ang1)-Ptt[1]*sin(ang1);
   Pt[1]=Ptt[0]*sin(ang1)+Ptt[1]*cos(ang1);
   Pt[2]=Ptt[2];
   N[(i*Csm+j)*3]=Pt[0];
   N[(i*Csm+j)*3+1]=Pt[1];
   N[(i*Csm+j)*3+2]=Pt[2];
  }
}

void main()
{
 createtorus();
 gl.MatrixMode(GL_PROJECTION);
 gl.LoadIdentity();
 gl.Frustum(-80,80,-60,60,100,200);
 gl.MatrixMode(GL_MODELVIEW);
 gl.Enable(GL_DOUBLEBUFFER);
 gl.Enable(GL_DEPTH_TEST);
 gl.Indexb(63);
 int zshift=-150;
 gl.Enable(GL_LIGHTING);
 gl.Enable(GL_NORMALIZE);
 gl.Enable(GL_PERSPECTIVE_CORRECTION);
 float Lpos[4]={-1,1,-1,0};
 gl.Lightfv(GL_LIGHT0,GL_POSITION,Lpos);
 gl.Lighti(GL_LIGHT0,GL_SPOT_EXPONENT,30);
 int i,j;
 for(i=0;i<64;i++)
 {
  gl.color(i,i,i,i);
  gl.color(i+64,i,0,0);
  gl.color(i+128,0,i,0);
  gl.color(i+192,0,0,i);
 }
 float ang1=0;
 int exit=0;
 unsigned char col=63;
 while(!exit)
 {
  if(kbhit())
   switch(getch())
   {
    case '0':gl.Disable(GL_LIGHTING);break;
    case '1':gl.Enable(GL_LIGHTING);gl.Disable(GL_PHONG_LIGHTING);gl.Disable(GL_PERSPECTIVE_CORRECTION);break;
    case '2':gl.Enable(GL_LIGHTING);gl.Disable(GL_PHONG_LIGHTING);gl.Enable(GL_PERSPECTIVE_CORRECTION);break;
    case '3':gl.Enable(GL_LIGHTING);gl.Enable(GL_PHONG_LIGHTING);gl.Disable(GL_PHONG_NORMALIZE);break;
    case '4':gl.Enable(GL_LIGHTING);gl.Enable(GL_PHONG_LIGHTING);gl.Enable(GL_PHONG_NORMALIZE);break;
    case ' ':gl.Indexb(col+=64);break;
    case '+':Clg++;createtorus();break;
    case '-':if(Clg>3){Clg--;createtorus();}break;
    case '*':Csm++;createtorus();break;
    case '/':if(Csm>3){Csm--;createtorus();}break;
    case 27:exit=1;
   }
  gl.Clear();
  gl.LoadIdentity();
  gl.Translatef(0,0,zshift);
  gl.Rotatef(ang1,0,1,0);
  ang1++;
  gl.Begin(GL_TRIANGLE_STRIP);
   for(i=1;i<Clg;i++)
   {
    for(j=0;j<Csm;j++)
    {
     gl.Normal3fv(N+(i*Csm+j)*3);
     gl.Vertex3fv(P+(i*Csm+j)*3);
     gl.Normal3fv(N+((i-1)*Csm+j)*3);
     gl.Vertex3fv(P+((i-1)*Csm+j)*3);
    }
    gl.Normal3fv(N+((i)*Csm+Csm-1)*3);
    gl.Vertex3fv(P+((i)*Csm+Csm-1)*3);
    gl.Normal3fv(N+((i)*Csm)*3);
    gl.Vertex3fv(P+((i)*Csm)*3);
   }
   for(j=0;j<Csm;j++)
   {
    gl.Normal3fv(N+(j)*3);
    gl.Vertex3fv(P+(j)*3);
    gl.Normal3fv(N+((Clg-1)*Csm+j)*3);
    gl.Vertex3fv(P+((Clg-1)*Csm+j)*3);
   }
   gl.Normal3fv(N+(Csm-1)*3);
   gl.Vertex3fv(P+(Csm-1)*3);
   gl.Normal3fv(N);
   gl.Vertex3fv(P);
   gl.Normal3fv(N+(Csm)*3);
   gl.Vertex3fv(P+(Csm)*3);
   gl.Normal3fv(N);
   gl.Vertex3fv(P);
  gl.End();
  gl.swapbuffers();
 }
 free(P);
 free(N);
}